#!/usr/local/bin/perl -w

# CS8761, Fall 2002
# Group Project
# LDOCE Dictionary interface module
# Group - SPORT BOYS
#         Aniruddha Mahajan
#         Anushri   Parsekar
#         Prashant  Rathi
#         Victoria  Harp         
# 



#use GetOpt::long;
#use strict;
use ldoce;
print "Loading database .....\n";
createhash();
print "OK\n\n";
$option = -1;
while($option!=0)
{
    system("clear");
    print "***********************************************\n";
    print "*         LDOCE DICTIONARY INTERFACE          *\n";
    print "***********************************************\n\n";
    print "MENU\n";
    print "1. Get info for a particular word\n";
    print "2. Get all Subject Codes present in LDOCE\n";
    print "3. Get list of all words having subject code of entered word\n";
    print "4. Get all words whose defn contains given words\n";
    print "0. Exit\n\n";
    print "Enter Option:- ";
    $option = <STDIN>;
    chomp($option);
    if($option ==  1)
    {
	print "Enter word:      ";
	$word = <STDIN>;
	print "\n";
	$ret = lget_word_info($word);
	print "m $ret m";
        print "\nPress any key to continue....."; <STDIN>;
    }
    
    if($option == 2)
    {  
	print "user.wait();\n"; 
	$ret = all_sub_codes(); 
	print "\nPrint output to file (y/n)? : ";
	$yn = <STDIN>; chomp($yn);
	if($yn eq 'y' || $yn eq 'Y')
	{
	    print "Enter FileName: ";
	    $flnm = <STDIN>; chomp($flnm);
	    open (IN, ">$flnm");
	    print IN $ret;
	    close IN;
	}
	else
	{
            print $ret;            
            print "\nPress any key to continue....."; <STDIN>;
	}
	
    }
    
    if($option == 3)
    {
	print "Enter word:      ";
	$word = <STDIN>;
	print " user.wait()\n";
	$ret = words_of_sub_codes($word);
	print "\nPrint output to file (y/n)? : ";
	$yn = <STDIN>; chomp($yn);
	if($yn eq 'y' || $yn eq 'Y')
	{
	    print "Enter FileName: ";
	    $flnm = <STDIN>; chomp($flnm);
	    open (IN, ">$flnm");
	    print IN $ret;
	    close IN;
	}
	else
	{           
	    print "m $ret m";
            print "\nPress any key to continue....."; <STDIN>;
	}
    }
    
    if($option == 4)
    {
	print "Enter words separated by spaces: ";
	$wstring = <STDIN>;
	chomp($wstring);        
	$ret = words_in_defs($wstring);
	print "m $ret m";
	print "\nPress any key to continue....."; <STDIN>;
    }
}



