
package WebReader::vista;
use LWP::UserAgent;    
use 5.008;
use warnings;
require Exporter;
our @ISA = qw(Exporter);


# CS8761, Fall 2002
# Group Project
# AltaVista MRD => Web Corpus
# Group - SPORT BOYS
#         Aniruddha Mahajan
#         Anushri   Parsekar
#         Prashant  Rathi
#         Victoria  Harp         
#         


# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(get_instance get_hits);

our $VERSION = '0.01';

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.
sub get_instance
{

    $word = $_[0]; 
    if($_[1])
    { 
        $maxpages = $_[1];
        $maxpages--; 
    }
    @warray = split/\+/, $word;   
    # Create a user agent object
    $ua = LWP::UserAgent->new();
    $url = "http://www.altavista.com/web/results?q=".$word."&kgs=0&kls=1&avkw=qtrp";    
    $res = $ua->get($url);
    $ret = '';
    # Check the outcome of the response
    if ($res->is_success) 
    {
   
    } 
    else 
    {
	print "Bad luck this time\n";
    }
    $cnt =0;
    $nexxt = $res->content;
    $rest = $res->content;
    while($rest =~ m/http/)          # PRINT ALL LINKS 1ST PAGE"
    {        
	$rest = $';                    # match later part'
	$rest =~ /"/;                  # "
	$addr = "http".$`;           # match previous part`
	$apostrophe = index($addr,"'");  
	if($apostrophe != -1)          #kill garbage at end of string
	{
	    $addr = substr($addr, 0 , $apostrophe);
	}
	$amp = index($addr,"&");  
	if($amp != -1)          #kill garbage at end of string
	{
	    $addr = substr($addr, 0 , $amp);
	}
        #avoid circular path through altavista.com
	$reject = index($addr,"http%");
	if($reject == -1)
	{
	    $reject = index($addr,"www.altavista.com"); 
	    if($reject == -1)
	    {
		$reject = index($addr,"http://jump.altavista.com"); #multiple links
		if($reject == -1)
		{
		    $reject = index($addr,".gif"); #cant read gifs
		    if($reject == -1)
		    {
			$reject = index($addr,".pdf");
			if($reject == -1)
			{
			    if(!defined $siteurl{$addr}) #if pass everything, add to list
			    {
				$siteurl{$addr} = $cnt;
				$cnt++;
			    }
			}
		    }
		}
	    }
	}
    }

    $c = 0;
    while($nexxt =~ m/\[Next &gt;&gt;\]/)   # " MATCH [NEXT >>] ON GIVEN PAGE
    {   
	if($_[1])
	{
           $c++;
	   if($c > $maxpages)
	   {
	       last; 
	   } 
        }
	$nexxt = $`;                      # previous part
	while($nexxt =~ m/href=/)   
	{
	      $nexxt = $';                  # '#   get later part  
        }
	$nexxt =~ m/"(.*)" /;
	$nexxt =$&;                            
	$nexxt =~ s/"//g;                      #" 
	$nexxt = "http://www.altavista.com".$nexxt;    # $nexxt CONTAINS LINK TO "next" PAGE           
	$res = $ua->get($nexxt);                       # go to 'next' page
	$nexxt = $res->content;
	$rest = $res->content;
	while($rest =~ m/http/)          # PRINT ALL LINKS 1ST PAGE"
	{        
	    $rest = $';                    # match later part'
	    $rest =~ /"/;                  # "
	    $addr = "http".$`;           # match previous part`
	    $apostrophe = index($addr,"'");  
	    if($apostrophe != -1)          #kill garbage at end of string
	    {
		$addr = substr($addr, 0 , $apostrophe);
	    }
	    $amp = index($addr,"&");  
	    if($amp != -1)          #kill garbage at end of string
	    {
		$addr = substr($addr, 0 , $amp);
	    }
	    #avoid circular path through altavista.com
	    $reject = index($addr,"http%");
	    if($reject == -1)
	    {
		$reject = index($addr,"www.altavista.com"); 
		if($reject == -1)
		{
		    $reject = index($addr,"http://jump.altavista.com"); #multiple links
		    if($reject == -1)
		    {
			$reject = index($addr,".gif"); #cant read gifs
			if($reject == -1)
			{
			    $reject = index($addr,".pdf");
			    if($reject == -1)
			    {
				if(!defined $siteurl{$addr}) #if pass everything, add to list
				{
				    $siteurl{$addr} = $cnt;
				    $cnt++;
				}
			    }
			}
		    }
		}
	    }
	}   
    }    
    getdata();
    return $ret;
}

sub getdata{
   
    $minsentence = 25;           #minimum sentence length
    foreach $key (keys (%siteurl))
    {       
	$glob = $ua->get($key);             
	$page = $glob->content;                                  # get page source
        $page =~ s/\n//g;
        $page =~ s/\s+/ /g;
        $page =~ s/[?!]/./g;    
        $page =~ s/<br>/./g;
        $page =~ s/<BR>/./g;
        #$page =~ s/(&nbsp)+/ /g;
        #$page =~ s/<(.*?)>//g;                                   # get rid of html tags     
        $page =~ s/<(.*) //g;
        $page =~ s/ (.*)>//g;
        $page =~ s/&(.*) //g;
        @parray = split /\./, $page;        
	for($j=0;$j<=$#parray;$j++)
        {   
            @marray = split/ /, $parray[$j];	   	    
	    if ($#marray > 5)                                    #continue if big enough
	    {
		$good = 1;                
		for($k=0;$k<=$#warray; $k++)                       #look for target words
		{
		    if(!($parray[$j] =~ m/ $warray[$k] /i))                 #if a target word not found   
		    {  
			$good = 0;
		    }
		    else
		    {
			#print uc($ARGV[$k]), "  $match\n";
		    }
		}                
		if($good)
		{      
                    $parray[$j] =~ s/\s+/ /g;
                    $parray[$j] =~ s/^\s+//;
		    $parray[$j] =~ s/\s+$//;
                    #print "$parray[$j].\n\n";              
		    $ret .= "$parray[$j].\n\n";
		}                 
	    }	    
	}
    }
}

sub get_hits 
{

    $word1 = $_[0]; 
    $word2 = $_[1]; 
    if($_[2])
    { 
        $maxpages = $_[2];
        $maxpages--; 
    }
    #@warray = split/\+/, $word;   
    # Create a user agent object
    $ua = LWP::UserAgent->new();
    #$url = "http://www.altavista.com/web/results?q=".$word."&kgs=0&kls=1&avkw=qtrp";  
    $url= "http://www.altavista.com/web/results?pg=aq&avkw=rf&filetype=&aqmode=b&aqb=".$word1."+NEAR+".$word2."&aqs=";
    $res = $ua->get($url);
    $ret = '';
    # Check the outcome of the response
    if ($res->is_success) 
    {
	$nexxt = $res->content;
	if($nexxt =~ m/AltaVista found /g)
	{
	    @remain = split/results/,$'; #'
       	    return $remain[0];
	}

    } 
    else 
    {
	print "Bad luck this time\n";
	return 0;
    }

}  
1;    
__END__

=head1 NAME

vista::vista - Perl module for searching the World Wide Web using Alta Vista

=head1 SYNOPSIS

  STEP 1:  In interface.pl include the code: 
      use vista;  

  STEP 2: From the command line, type:
      % perl interface.pl vista.pm 

 
=head1 DESCRIPTION

The module recursively searches www.altavista.com for the target words
specified on the command line.  When the module finds a sentence where all
the words occurred, it prints the sentence to STDIN.  The order of the
target words does not matter.

The program will not return sentences shorter than 5 words.

This program may take up to 5 minutes to complete the search.

=head1 USAGE

   % interface.pl vista.pm 

=head1 EXPORT

$returnval = get_instance($words,[pages]);
where:
       $returnval is the string of sentences as returned by get_instance()
       $words     is the words to be searched for as explained below
       pages      is the number of altavista result pages to be searched 
                  [default is all possible pages] 
       

method get_instance() requires a string of words [to be searched] separated
by a '+' character.
e.g. coal+miner 


get_instance() Invokes a recursive search on www.altavista.com using ARGV
arguments.


=head1 SEE ALSO

    /usr/local/bin/lwp-download
    /usr/local/bin/lwp-mirror
    /usr/local/bin/lwp-request 
    /usr/local/bin/lwp-rget

    LWP::UserAgent


=head1 AUTHORS

Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp. 

=head1 COPYRIGHT AND LICENSE

Copyright 2002 by Aniruddha Mahajan, Anushri Parsekar, Prashant Rathi, and
Victoria Harp.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut
